#ifndef INCLUDED_BrowseWindow_h
#define INCLUDED_BrowseWindow_h

#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

#include "Controller.h"

@interface BrowseWindow : NSWindow
{
    Controller *con;
    NSBrowser *browser;
    NSString *err, *srv;
    NSString *last; // not retained
    BOOL umount;
}

- initWithController:(Controller *)control;

- (NSBrowser *)browser;
- (NSString *)error;

- (NSString *)domain;
- (NSString *)fullShare;

- (void)columnLoaded:(NSNotification*)notification;

- (NSString *)browser:(NSBrowser *)sender titleOfColumn:(int)column;
- (void)browser:(NSBrowser *)sender createRowsForColumn:(int)column
       inMatrix:(NSMatrix *)matrix;

- umountModal:(id)sender;

- refresh:(id)sender;
- upload:(id)sender;
- download:(id)sender;
- delete:(id)sender;
- mkdir:(id)sender;
- rmdir:(id)sender;
- putTAR:(id)sender;
- getTAR:(id)sender;
- mount:(id)sender;
- umount:(id)sender;
- winpopup:(id)sender;
- sprint:(id)sender;

- (BOOL)validateMenuItem:(id <NSMenuItem>)menuItem;

- cleanup;

@end

#endif
