#ifndef INCLUDED_Controller_h
#define INCLUDED_Controller_h

#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

#include "KnobView.h"

typedef enum {
    STR_RESTR = 1,
    STR_GRAPH = 2,
    STR_ILLEGAL = 4
} STR_TYPE;

typedef struct {
    NSString *share;
    NSString *path;
} MInfo;

@interface Controller : NSObject
{
    NSWindow *prefs;
    NSTextField *userf, *passwdf,
        *smbclientf, 
        *smbmountf, *smbumountf, *mountf,
        *nmblookupf;

    NSPanel *progPanel;
    KnobView *progInd;
    BOOL interrupted;
}

-(void)applicationDidFinishLaunching:(NSNotification *)aNotification;

- makePreferences;
- runPreferencesPanel:(id)sender;

- makeProgPanel;
- progStop:(id)sender;

- browseBinary:(id)sender;

- (BOOL)checkBinary:(NSString *)name title:(NSString *)tstr;
- (STR_TYPE)classifyString:(NSString *)name;

- checkFields;

- readDefaults:(id)sender;
- setDefaults:(id)sender;
- setEntered:(id)sender;

- (NSString *)user;
- (NSString *)password;
- (NSString *)userAndPassword;

- (NSString *)smbclient;
- (NSString *)smbmount;
- (NSString *)smbumount;
- (NSString *)mount;
- (NSString *)nmblookup;

- newBrowser:(id)sender;

- (NSEnumerator *)runCommand:(NSString *)cmd arguments:(NSArray *)args
                       input:(NSString *)inStr
                    progress:(BOOL)prog;

- (NSMutableArray *)mountedFSystemsOfType:(NSString *)type
                                    share:(NSString *)aShare;


- (void)windowWillClose:(NSNotification *)aNotification;

@end

#endif
