
#include <time.h>
#include <unistd.h>
#include <fcntl.h>


#include "Controller.h"
#include "BrowseWindow.h"

@implementation Controller

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    [self makePreferences];
    [self makeProgPanel];
}

#define WIDTH       300
#define HEIGHT       50

#define PAD @"------------------------------------------------"

typedef enum {
    TAG_SMBCLIENT = 0,
    TAG_SMBMOUNT,
    TAG_SMBUMOUNT,
    TAG_MOUNT,
    TAG_NMBLOOKUP,
    TAG_ALL
} BINTAGS;

- makePreferences
{
    NSBox *box;
    NSButton *button;
    NSView *contentView, *boxContentView;
    NSRect winRect = {{250, 100}, {0, 50}}, bframe;
    unsigned int style = NSTitledWindowMask | NSClosableWindowMask |
        NSMiniaturizableWindowMask | NSResizableWindowMask;
    float delta;

    passwdf = [NSTextField new];
    [passwdf setStringValue:PAD];
    [passwdf sizeToFit];
    [passwdf setEditable:YES];
    [passwdf setAutoresizingMask:
               (NSViewWidthSizable |
                NSViewMinYMargin | NSViewMaxYMargin)];

    box = 
        [[NSBox alloc] 
            initWithFrame:NSMakeRect(0, winRect.size.height, WIDTH, HEIGHT)];
    [box setContentView:passwdf];
    [box setContentViewMargins:NSMakeSize(5, 5)];
    [box setTitle:@"Password"];
    [box setBorderType:NSGrooveBorder];
    [box sizeToFit];
    [box setAutoresizingMask:
             (NSViewWidthSizable | NSViewMinYMargin)];

    bframe = [box frame];
    winRect.size.width += bframe.size.width;
    winRect.size.height += bframe.size.height;

    userf = [NSTextField new];
    [userf setStringValue:PAD];
    [userf sizeToFit];
    [userf setEditable:YES];
    [userf setAutoresizingMask:
               (NSViewWidthSizable |
                NSViewMinYMargin | NSViewMaxYMargin)];

    box = 
        [[NSBox alloc] 
            initWithFrame:NSMakeRect(0, winRect.size.height, WIDTH, HEIGHT)];
    [box setContentView:userf];
    [box setContentViewMargins:NSMakeSize(5, 5)];
    [box setTitle:@"User"];
    [box setBorderType:NSGrooveBorder];
    [box sizeToFit];
    [box setAutoresizingMask:
             (NSViewWidthSizable | NSViewMinYMargin)];

    winRect.size.height += bframe.size.height;

    smbclientf = [NSTextField new];
    [smbclientf setStringValue:PAD];
    [smbclientf sizeToFit];
    [smbclientf setEditable:YES];
    [smbclientf setAutoresizingMask:
               (NSViewWidthSizable |
                NSViewMinYMargin | NSViewMaxYMargin)];

    button = [NSButton new];
    [button setTitle:@"Browse ..."];
    [button setTarget:self];
    [button setTag:TAG_SMBCLIENT];
    [button setAction:@selector(browseBinary:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]-2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMinXMargin];

    delta = [smbclientf frame].size.width-[button frame].size.width;
    [smbclientf 
        setFrameSize: 
            NSMakeSize(delta-5, [smbclientf frame].size.height)];
    [button 
        setFrameOrigin:
            NSMakePoint(delta, 0)];
    boxContentView =
        [[NSView alloc] initWithFrame:[[box contentView] frame]];
    [boxContentView addSubview:smbclientf];
    [boxContentView addSubview:button];


    box = 
        [[NSBox alloc] 
            initWithFrame:NSMakeRect(0, winRect.size.height, 
                                     bframe.size.width, bframe.size.height)];
    [box setContentView:boxContentView];
    [box setContentViewMargins:NSMakeSize(5, 5)];
    [box setTitle:@"SMBCLIENT"];
    [box setBorderType:NSGrooveBorder];
    [box setAutoresizingMask:
             (NSViewWidthSizable | NSViewMinYMargin)];

    winRect.size.height += bframe.size.height;

    smbumountf = [NSTextField new];
    [smbumountf setStringValue:PAD];
    [smbumountf sizeToFit];
    [smbumountf setEditable:YES];
    [smbumountf setAutoresizingMask:
               (NSViewWidthSizable |
                NSViewMinYMargin | NSViewMaxYMargin)];

    button = [NSButton new];
    [button setTitle:@"Browse ..."];
    [button setTarget:self];
    [button setTag:TAG_SMBUMOUNT];
    [button setAction:@selector(browseBinary:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]-2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMinXMargin];

    delta = [smbumountf frame].size.width-[button frame].size.width;
    [smbumountf 
        setFrameSize: 
            NSMakeSize(delta-5, [smbumountf frame].size.height)];
    [button 
        setFrameOrigin:
            NSMakePoint(delta, 0)];
    boxContentView =
        [[NSView alloc] initWithFrame:[[box contentView] frame]];
    [boxContentView addSubview:smbumountf];
    [boxContentView addSubview:button];


    box = 
        [[NSBox alloc] 
            initWithFrame:NSMakeRect(0, winRect.size.height, 
                                     bframe.size.width, bframe.size.height)];
    [box setContentView:boxContentView];
    [box setContentViewMargins:NSMakeSize(5, 5)];
    [box setTitle:@"SMBUMOUNT"];
    [box setBorderType:NSGrooveBorder];
    [box setAutoresizingMask:
             (NSViewWidthSizable | NSViewMinYMargin)];

    winRect.size.height += bframe.size.height;

    smbmountf = [NSTextField new];
    [smbmountf setStringValue:PAD];
    [smbmountf sizeToFit];
    [smbmountf setEditable:YES];
    [smbmountf setAutoresizingMask:
               (NSViewWidthSizable |
                NSViewMinYMargin | NSViewMaxYMargin)];

    button = [NSButton new];
    [button setTitle:@"Browse ..."];
    [button setTarget:self];
    [button setTag:TAG_SMBMOUNT];
    [button setAction:@selector(browseBinary:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]-2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMinXMargin];

    delta = [smbmountf frame].size.width-[button frame].size.width;
    [smbmountf 
        setFrameSize: 
            NSMakeSize(delta-5, [smbmountf frame].size.height)];
    [button 
        setFrameOrigin:
            NSMakePoint(delta, 0)];
    boxContentView =
        [[NSView alloc] initWithFrame:[[box contentView] frame]];
    [boxContentView addSubview:smbmountf];
    [boxContentView addSubview:button];


    box = 
        [[NSBox alloc] 
            initWithFrame:NSMakeRect(0, winRect.size.height, 
                                     bframe.size.width, bframe.size.height)];
    [box setContentView:boxContentView];
    [box setContentViewMargins:NSMakeSize(5, 5)];
    [box setTitle:@"SMBMOUNT"];
    [box setBorderType:NSGrooveBorder];
    [box setAutoresizingMask:
             (NSViewWidthSizable | NSViewMinYMargin)];

    winRect.size.height += bframe.size.height;

    mountf = [NSTextField new];
    [mountf setStringValue:PAD];
    [mountf sizeToFit];
    [mountf setEditable:YES];
    [mountf setAutoresizingMask:
               (NSViewWidthSizable |
                NSViewMinYMargin | NSViewMaxYMargin)];

    button = [NSButton new];
    [button setTitle:@"Browse ..."];
    [button setTarget:self];
    [button setTag:TAG_MOUNT];
    [button setAction:@selector(browseBinary:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]-2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMinXMargin];

    delta = [mountf frame].size.width-[button frame].size.width;
    [mountf 
        setFrameSize: 
            NSMakeSize(delta-5, [mountf frame].size.height)];
    [button 
        setFrameOrigin:
            NSMakePoint(delta, 0)];
    boxContentView =
        [[NSView alloc] initWithFrame:[[box contentView] frame]];
    [boxContentView addSubview:mountf];
    [boxContentView addSubview:button];


    box = 
        [[NSBox alloc] 
            initWithFrame:NSMakeRect(0, winRect.size.height, 
                                     bframe.size.width, bframe.size.height)];
    [box setContentView:boxContentView];
    [box setContentViewMargins:NSMakeSize(5, 5)];
    [box setTitle:@"MOUNT"];
    [box setBorderType:NSGrooveBorder];
    [box setAutoresizingMask:
             (NSViewWidthSizable | NSViewMinYMargin)];

    winRect.size.height += bframe.size.height;


    nmblookupf = [NSTextField new];
    [nmblookupf setStringValue:PAD];
    [nmblookupf sizeToFit];
    [nmblookupf setEditable:YES];
    [nmblookupf setAutoresizingMask:
               (NSViewWidthSizable |
                NSViewMinYMargin | NSViewMaxYMargin)];

    button = [NSButton new];
    [button setTitle:@"Browse ..."];
    [button setTarget:self];
    [button setTag:TAG_NMBLOOKUP];
    [button setAction:@selector(browseBinary:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]-2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMinXMargin];

    delta = [nmblookupf frame].size.width-[button frame].size.width;
    [nmblookupf 
        setFrameSize: 
            NSMakeSize(delta-5, [nmblookupf frame].size.height)];
    [button 
        setFrameOrigin:
            NSMakePoint(delta, 0)];
    boxContentView =
        [[NSView alloc] initWithFrame:[[box contentView] frame]];
    [boxContentView addSubview:nmblookupf];
    [boxContentView addSubview:button];


    box = 
        [[NSBox alloc] 
            initWithFrame:NSMakeRect(0, winRect.size.height, 
                                     bframe.size.width, bframe.size.height)];
    [box setContentView:boxContentView];
    [box setContentViewMargins:NSMakeSize(5, 5)];
    [box setTitle:@"NMBLOOKUP"];
    [box setBorderType:NSGrooveBorder];
    [box setAutoresizingMask:
             (NSViewWidthSizable | NSViewMinYMargin)];

    winRect.size.height += bframe.size.height;

    contentView = 
        [[NSView alloc] 
            initWithFrame:NSMakeRect(0, 0,
                                     winRect.size.width,
                                     winRect.size.height)];

    [contentView addSubview:[passwdf superview]];
    [contentView addSubview:[userf superview]];
    [contentView addSubview:[[smbclientf superview] superview]];
    [contentView addSubview:[[smbmountf superview] superview]];
    [contentView addSubview:[[smbumountf superview] superview]];
    [contentView addSubview:[[mountf superview] superview]];
    [contentView addSubview:[[nmblookupf superview] superview]];

    [nmblookupf setNextKeyView:mountf];
    [mountf     setNextKeyView:smbmountf];
    [smbmountf  setNextKeyView:smbumountf];
    [smbumountf setNextKeyView:smbclientf];
    [smbclientf setNextKeyView:userf];
    [userf      setNextKeyView:passwdf];
    [passwdf    setNextKeyView:nmblookupf];

    button = [NSButton new];
    [button setTitle:@"Defaults"];
    [button setTarget:self];
    [button setAction:@selector(setDefaults:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]+2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMaxXMargin];
    [button setFrameOrigin:
                NSMakePoint(5, 5)];

    [contentView addSubview:button];

    button = [NSButton new];
    [button setTitle:@"Reread"];
    [button setTarget:self];
    [button setAction:@selector(readDefaults:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]+2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMinXMargin];
    [button setFrameOrigin:
                NSMakePoint((bframe.size.width-
                             [button frame].size.width)/2.0, 5)];

    [contentView addSubview:button];

    button = [NSButton new];
    [button setTitle:@"Set"];
    [button setTarget:self];
    [button setAction:@selector(setEntered:)];
    [button setFont:[NSFont labelFontOfSize:
                                [[button font] pointSize]+2]];
    [button sizeToFit];
    [button setAutoresizingMask:NSViewMinXMargin];
    [button setFrameOrigin:
                NSMakePoint(bframe.size.width-
                            [button frame].size.width-5, 5)];

    [contentView addSubview:button];

    [self readDefaults:nil];

    prefs = [[NSWindow alloc] initWithContentRect:winRect
                              styleMask:style
                              backing:NSBackingStoreRetained
                              defer:NO];
    [prefs setMinSize:[contentView frame].size];
    [prefs setContentView:contentView];
    [prefs setReleasedWhenClosed:NO];
    [prefs setTitle:@"Preferences"];

    return self;
}

- runPreferencesPanel:(id)sender
{
    [prefs makeKeyAndOrderFront:self];
    [[NSApplication sharedApplication]
        runModalForWindow:prefs];
    return self;
}

#define PROGWIDTH 300

- makeProgPanel
{
    NSRect contentFrame, stopperFrame, knobFrame;
    int style =  NSTitledWindowMask | NSClosableWindowMask;
    NSButton *progStopper;
    NSView *cview;

    progStopper = [NSButton new];
    [progStopper setTitle:@"Stop"];
    [progStopper setTarget:self];
    [progStopper setAction:@selector(progStop:)];
    [progStopper sizeToFit];
    stopperFrame = [progStopper frame];
    [progStopper 
        setFrameOrigin:
            NSMakePoint((PROGWIDTH-stopperFrame.size.width)/2, 5)];

    knobFrame.origin = NSMakePoint(0, 5+stopperFrame.size.height+5);
    knobFrame.size   = NSMakeSize(PROGWIDTH, 25);
    progInd = [[KnobView alloc] initWithFrame:knobFrame];
    [progInd setPercent:0.0];

    contentFrame = 
        NSMakeRect(0, 0, PROGWIDTH,
                   5+stopperFrame.size.height+5+knobFrame.size.height);
    progPanel = [[NSPanel alloc]
                    initWithContentRect:contentFrame
                    styleMask:style
                    backing:NSBackingStoreBuffered
                    defer:NO];
    [progPanel setReleasedWhenClosed:NO];

    cview = [progPanel contentView];
    [cview addSubview:progStopper];
    [cview addSubview:progInd];

    return self;
}

- progStop:(id)sender
{
    interrupted = YES;
    return self;
}

- browseBinary:(id)sender
{
  NSOpenPanel *openPanel;
  NSString    *file;
  int result, tag = [sender tag];
  const char *title[TAG_ALL] = { 
      "SMBCLIENT", 
      "SMBMOUNT", "SMBUMOUNT", "MOUNT",
      "NMBLOOKUP" 
  };
  id fields[TAG_ALL] = { 
      smbclientf, 
      smbmountf, smbumountf, mountf,
      nmblookupf 
  };

  openPanel = [NSOpenPanel openPanel];
  
  [openPanel 
      setTitle:[NSString 
                   stringWithFormat:
                       @"Choose Command for %s", title[tag]]];
  [openPanel setAllowsMultipleSelection:NO];
  [openPanel setPrompt: 
                 [NSString stringWithFormat:@"%s Command:", title[tag]]];
  [openPanel setCanChooseDirectories:NO];

  file = [fields[tag] stringValue];

  result = 
      [openPanel 
          runModalForDirectory:[file stringByDeletingLastPathComponent]
          file:[file lastPathComponent] types:nil];

  if(result==NSOKButton){
      [fields[tag] setStringValue:[openPanel filename]];
  }

  return self;
}

- (BOOL)checkBinary:(NSString *)name title:(NSString *)tstr
{
    NSFileManager *fm = [NSFileManager defaultManager];
    BOOL isDir;
    NSString *alert = nil;

    if([fm fileExistsAtPath:name isDirectory:&isDir]==YES){
        if(isDir==YES){
            alert = 
                [NSString stringWithFormat:
                              @"%@ binary %@ is a directory", tstr, name];
        }
        else if([fm isExecutableFileAtPath:name]==NO){
            alert = 
                [NSString stringWithFormat:
                              @"%@ binary %@ is not executable", tstr, name];
        }
    }
    else{
        alert = 
            [NSString stringWithFormat:
                          @"%@ binary %@ does not exist", tstr, name];
    }

    if(alert!=nil){
        NSRunAlertPanel(@"Error", alert, @"OK", NULL, NULL);
        return NO;
    }

    return YES;
}

- (STR_TYPE)classifyString:(NSString *)name
{
    const char *str = [name cString];
    char c;
    STR_TYPE stype = STR_RESTR;

    while(c=*str++){
        if(!isalnum(c) && c!='-' && c!='_'){
            if(isgraph(c)){
                stype = STR_GRAPH;
            }
            else{
                stype = STR_ILLEGAL;
                break;
            }
        }
    };

    return stype;
}

- checkFields
{
    NSString *str, *names[2] = { 
        @"user", @"password"
    };
    int ind, valid[2] = {
        STR_RESTR, STR_RESTR | STR_GRAPH
    };
    id fields[2] = { userf, passwdf};
    
    for(ind=0; ind<2; ind++){
        NSString *alert = nil;
        str = [fields[ind] stringValue];
        if(![str length]){
            alert = 
                [NSString stringWithFormat:
                              @"Field is empty: %@", names[ind]];
        }
        else if(!([self classifyString:str] & valid[ind])){
            alert = 
                [NSString stringWithFormat:
                              @"Illegal character: %@", names[ind]];
        } 
        if(alert!=nil){
            NSRunAlertPanel(@"Error", alert, @"Ok", NULL, NULL);
            return nil;
        }
    }

    if([self checkBinary:[smbclientf stringValue]
             title:@"smbclient"]==NO){
        return nil;
    }
    if([self checkBinary:[smbmountf stringValue]
             title:@"smbmount"]==NO){
        return nil;
    }
    if([self checkBinary:[smbumountf stringValue]
             title:@"smbumount"]==NO){
        return nil;
    }
    if([self checkBinary:[mountf stringValue]
             title:@"mount"]==NO){
        return nil;
    }
    if([self checkBinary:[nmblookupf stringValue]
             title:@"nmblookup"]==NO){
        return nil;
    }

    return self;
}

- readDefaults:(id)sender
{
    NSUserDefaults *ud = [NSUserDefaults standardUserDefaults];

    [passwdf setStringValue:
                 [ud stringForKey:@"passwd"]];
    [userf setStringValue:
                 [ud stringForKey:@"user"]];
    [smbclientf setStringValue:
                 [ud stringForKey:@"smbclient"]];
    [smbmountf setStringValue:
                 [ud stringForKey:@"smbmount"]];
    [smbumountf setStringValue:
                    [ud stringForKey:@"smbumount"]];
    [mountf setStringValue:
                [ud stringForKey:@"mount"]];
    [nmblookupf setStringValue:
                 [ud stringForKey:@"nmblookup"]];

    return self;
}

- setDefaults:(id)sender
{
    [passwdf setStringValue:@"SOMEPASSWD"];
    [userf setStringValue:@"SOMEUSER"];
    [smbclientf setStringValue:@"/usr/bin/smbclient"];
    [smbmountf setStringValue:@"/usr/bin/smbmount"];
    [smbumountf setStringValue:@"/usr/bin/smbumount"];
    [mountf setStringValue:@"/bin/mount"];
    [nmblookupf setStringValue:@"/usr/bin/nmblookup"];

    return self;
}



- setEntered:(id)sender
{
    NSUserDefaults *ud = [NSUserDefaults standardUserDefaults];

    if([self checkFields]==nil){
        return self;
    }

    [ud setObject:[passwdf stringValue] forKey:@"passwd"];
    [ud setObject:[userf stringValue] forKey:@"user"];
    [ud setObject:[smbclientf stringValue] forKey:@"smbclient"];
    [ud setObject:[smbmountf stringValue] forKey:@"smbmount"];
    [ud setObject:[smbumountf stringValue] forKey:@"smbumount"];
    [ud setObject:[mountf stringValue] forKey:@"mount"];
    [ud setObject:[nmblookupf stringValue] forKey:@"nmblookup"];

    [ud synchronize];

    [[NSApplication sharedApplication]
        stopModal];
    [prefs orderOut:self];

    return self;
}

- (NSString *)user
{
    return [userf stringValue];
}

- (NSString *)password
{
    return [passwdf stringValue];
}

- (NSString *)userAndPassword
{
    return [NSString stringWithFormat:@"%@%%%@",
                     [userf stringValue],
                     [passwdf stringValue]];
}

- (NSString *)smbclient
{
    return [smbclientf stringValue];
}

- (NSString *)smbmount
{
    return [smbmountf stringValue];
}

- (NSString *)smbumount
{
    return [smbumountf stringValue];
}

- (NSString *)mount
{
    return [mountf stringValue];
}

- (NSString *)nmblookup
{
    return [nmblookupf stringValue];
}

- newBrowser:(id)sender
{
    BrowseWindow *bw;
    NSString *error;

    if([self checkFields]==nil){
        [self runPreferencesPanel:nil];
        return self;
    }
    
    [[BrowseWindow alloc] initWithController:self];

    return self;
}

#define BUFSIZE    4096
#define INTERVAL      3

#define ERRMSG     "ERRGSMBrowser -- transfer interrupted"

- (NSEnumerator *)runCommand:(NSString *)cmd arguments:(NSArray *)args
                       input:(NSString *)inStr
                    progress:(BOOL)prog
{
    NSPipe *inputPipe, *outputPipe;
    NSFileHandle *reader, *writer;
    NSMutableData *data = [NSMutableData dataWithCapacity:1024];
    NSTask *cmdTask = [NSTask new];

    int ticks = 0;

    int fd, len;
    char *buf[BUFSIZE];
    
    unsigned length;
    const char *bytes;

    NSApplication *app = [NSApplication sharedApplication];
    NSModalSession progSession;
    BOOL pflag = NO;
    NSDate *progDate;

    int mask = NSLeftMouseDownMask | NSLeftMouseUpMask |
        NSLeftMouseDraggedMask;
    NSDate *evDate;
    NSEvent *event;

    NSLog(@"%@ %@", cmd, args);

    outputPipe = [NSPipe pipe];
    reader = [outputPipe fileHandleForReading];

    fd = [reader fileDescriptor];
    fcntl(fd, F_SETFL, O_NONBLOCK);

    inputPipe = [NSPipe pipe];
    writer = [inputPipe fileHandleForWriting];

    [cmdTask setLaunchPath:cmd];
    [cmdTask setArguments:args];

    [cmdTask setStandardInput:inputPipe];
    [cmdTask setStandardOutput:outputPipe];
    [cmdTask setStandardError:outputPipe];

    [cmdTask launch]; interrupted = NO;
    progDate = [NSDate dateWithTimeIntervalSinceNow:INTERVAL];

    if(inStr!=nil){
        [writer writeData:[inStr dataUsingEncoding:NSASCIIStringEncoding]];
    }
    [writer closeFile];

    while(len = read(fd, buf, BUFSIZE)){
        if(len>0){
            [data appendBytes:buf length:len];
        }
        else{
            if(prog==YES && pflag==NO && 
               [progDate timeIntervalSinceNow]<0.0){
                [progPanel 
                    setTitle:[NSString stringWithFormat:@"Running %@", cmd]];

                progSession = [app beginModalSessionForWindow:progPanel];
                pflag = YES;
                [[NSCursor arrowCursor] push];
            }
            else if(pflag==YES){
                ticks = (ticks+1)%200;
                [progInd 
                    setPercent:(float)(ticks<100 ? ticks : 199-ticks)];
                [progInd display];
                [progPanel flushWindow];

                evDate = [NSDate dateWithTimeIntervalSinceNow:0.025];
                event  = [app nextEventMatchingMask:mask 
                              untilDate:evDate
                              inMode:NSDefaultRunLoopMode
                              dequeue:YES];
                if([event window]==progPanel){
                    [app sendEvent:event];
                }
                if(interrupted==YES){
                    [cmdTask terminate];
                    data = [NSData dataWithBytes:ERRMSG
                                   length:strlen(ERRMSG)];
                    break;
                }
            }
            [NSThread 
                sleepUntilDate:
                    [NSDate dateWithTimeIntervalSinceNow:0.025]];
        }
    }

    if(pflag==YES){
        [app endModalSession:progSession];
        [progPanel close];
        [NSCursor pop];
    }

    length = [data length];
    bytes  = [data bytes];

    if(length && bytes[length-1]=='\n'){
        length--;
    }

    return
        [[[NSString stringWithCString:bytes length:length] 
             componentsSeparatedByString:@"\n"]
            objectEnumerator];
}


- (NSMutableArray *)mountedFSystemsOfType:(NSString *)type
                                    share:(NSString *)aShare
{
    NSEnumerator *cmdOutput;
    NSString *line, *typeStr = @" type ";
    const char *ctypeStr;
    int typeLen;
    NSMutableArray *result = [NSMutableArray arrayWithCapacity:16];

    if(type!=nil){
        typeStr = [typeStr stringByAppendingString:type];
    }
    ctypeStr = [typeStr cString];
    typeLen  = [typeStr length];

    cmdOutput = 
        [self runCommand:[self mount] arguments:nil 
              input:nil progress:YES];
    
    while(line =[cmdOutput nextObject]){
        const char *start = [line cString], *lower, *upper;
        if(start!=NULL){
            lower = start;
            while(!isspace(*lower)){
                lower++;
            }
            if(!strncmp(lower, " on ", 4) && !isspace(lower[4])){
                upper = lower + [line length]-1;
                while(upper>lower && 
                      strncmp(upper, ctypeStr, typeLen)){
                    upper--;
                }
                if(upper>lower){
                    NSString *path = @"";
                    const char *str;
                    MInfo mi;
                    
                    mi.share = [NSString stringWithCString:start
                                      length:lower-start];
                    mi.path = [NSString stringWithCString:lower+4
                                        length:upper-(lower+4)];

                    str = [mi.path cString];
                    NSAssert(str!=NULL, @"empty path");
                    while(*str){
                        if(str[0]=='\\' && str[1]=='\\'){
                            str++;
                        }
                        path = [path stringByAppendingFormat:@"%c",
                                     str[0]];
                        str++;
                    }
                    mi.path = path;
                    
                    if(aShare==nil || [mi.share isEqual:aShare]==YES){
                        [result 
                            addObject:
                                [NSValue valueWithBytes:&mi
                                         objCType:@encode(MInfo)]];
                    }
                }
            }
        }
    }

    return result;
}

- (void)windowWillClose:(NSNotification *)aNotification
{
    [(BrowseWindow *)[aNotification object] cleanup];
}

@end
